// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "SimpleCObject.h"
#include "ChildView.h"
#include "Point3D.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CChildView

CChildView::CChildView()
{
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
END_MESSAGE_MAP()



// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	dc.TextOut(100, 100, CString("CObject derived class  CPoint3D ǽðŬ, ü, ȭ Դϴ."));

	// CObject derived class - dynamic object creation
	CString aMsg, bMsg, cMsg;
	CObject *ptrObj = (CObject *) RUNTIME_CLASS(CPoint3D)->CreateObject(); //  ü 
	ASSERT(ptrObj->IsKindOf(RUNTIME_CLASS(CPoint3D))); // Ÿ缺 
	if(ptrObj->IsKindOf(RUNTIME_CLASS(CPoint3D))) {	// ǽð Ŭ 
		CPoint3D *a = (CPoint3D *) ptrObj;
		a->SetPosition(10,20,30);
		aMsg.Format("a (%d, %d, %d)", a->GetX(), a->GetY(), a->GetZ());
		dc.TextOut(100, 120, (LPCTSTR)aMsg);	//  â a 

		CPoint3D *b = (CPoint3D *) ptrObj;
		b->SetPosition(40,50,60);
		bMsg.Format("b (%d, %d, %d)", b->GetX(), b->GetY(), b->GetZ());
		dc.TextOut(100, 140, (LPCTSTR)bMsg);	//  â b 

		CPoint3D *c = (CPoint3D *) ptrObj;
		c->SetPosition(70,80,90);
		cMsg.Format("c (%d, %d, %d)", c->GetX(), c->GetY(), c->GetZ());
		dc.TextOut(100, 160, (LPCTSTR)cMsg);	//  â b 
	}

	// serialization - write & read
	TRY		// 
	{
		CPoint3D d(100,200,300);
		CPoint3D e(400,500,600);
		CPoint3D f(700,800,900);
		CFile file;
		file.Open(_T("Point.dat"), CFile::modeCreate | CFile::modeWrite);
		CArchive ar(&file, CArchive::store);
		d.Serialize(ar);
		e.Serialize(ar);
		f.Serialize(ar);
	}
	CATCH(CFileException, e)
	{
		e->ReportError();
	}
	END_CATCH

	TRY		// б
	{
		CPoint3D point;
		CFile file;
		file.Open(_T("Point.dat"), CFile::modeRead);
		CArchive ar(&file, CArchive::load);
		
		point.Serialize(ar);
		TRACE("(%d, %d, %d)\n", point.GetX(), point.GetY(), point.GetZ());
		point.Serialize(ar);
		TRACE("(%d, %d, %d)\n", point.GetX(), point.GetY(), point.GetZ());
		point.Serialize(ar);
		TRACE("(%d, %d, %d)\n", point.GetX(), point.GetY(), point.GetZ());
	}
	CATCH(CFileException, e)
	{
		e->ReportError();
	}
	END_CATCH

	// Do not call CWnd::OnPaint() for painting messages
}

