#pragma once

// CPoint3D command target

class CPoint3D : public CObject
{
	DECLARE_SERIAL(CPoint3D)	// ǽðŬ, ü, ȭ

public:
	CPoint3D();
	CPoint3D(int x, int y, int z);
	CPoint3D(const CPoint3D& other);
	CPoint3D(const int * other);
	virtual ~CPoint3D();
	void Serialize(CArchive& ar);
#ifdef _DEBUG
	virtual void AssertValid() const;	// this pointer NULLƴ 
#endif

	// member function
	void SetPosition(int nX=10, int nY=10, int nZ=10);	// default parameter
	void Move(int nX, int nY, int nZ);
	void Show();
	int GetX() {return m_nX; }
	int GetY() {return m_nY; }
	int GetZ() {return m_nZ; }

	// operator overloading
	CPoint3D& operator++();
	CPoint3D operator+(const CPoint3D& other);
	int operator<(const CPoint3D& other) const;
	int operator==(const CPoint3D& other) const;

private:
	int m_nX, m_nY, m_nZ;
};


